<?php

/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */
namespace FiloBlu\OrderAdditionalData\Model;

use FiloBlu\OrderAdditionalData\Api\ProductOptionInterface;

/**
 * OAD Order Item Additional Data
 */
class ProductOption extends \Magento\Framework\DataObject implements ProductOptionInterface
{
    /**
     * @return string|null
     */
    public function getLabel(){ 
        return $this->getData("label");
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setLabel($data){ 
        return $this->setData("label", $data);
    }

    /**
     * @return string|null
     */
    public function getValue(){ 
        return $this->getData("value");
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setValue($data){ 
        return $this->setData("value", $data);
    }

    /**
     * @return string|null
     */
    public function getPrintValue(){ 
        return $this->getData("print_value");
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setPrintValue($data){ 
        return $this->setData("print_value", $data);
    }

    /**
     * @return string|null
     */
    public function getOptionId(){ 
        return $this->getData("option_id");
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setOptionId($data){ 
        return $this->setData("option_id", $data);
    }

    /**
     * @return string|null
     */
    public function getOptionType(){ 
        return $this->getData("option_type");
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setOptionType($data){ 
        return $this->setData("option_type", $data);
    }

    /**
     * @return string|null
     */
    public function getOptionValue(){ 
        return $this->getData("option_value");
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setOptionValue($data){ 
        return $this->setData("option_value", $data);
    }

    /**
     * @return string|null
     */
    public function getCustomView(){ 
        return $this->getData("custom_view");
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setCustomView($data){ 
        return $this->setData("custom_view", $data);
    }

    /**
     * Retrieve existing extension attributes object or create a new one.
     *
     * @return \Magento\Catalog\Api\Data\ProductOptionExtensionInterface|null
     */
    public function getExtensionAttributes(){
        return $this->getData("extension_attributes");
    }

    /**
     * Set an extension attributes object.
     *
     * @param \Magento\Catalog\Api\Data\ProductOptionExtensionInterface $extensionAttributes
     * @return $this
     */
    public function setExtensionAttributes(
        \Magento\Catalog\Api\Data\ProductOptionExtensionInterface $extensionAttributes
    ){
        return $this->setData("extension_attributes", $extensionAttributes);
    }
}